% Find the insertion position of a string among a list of strings.
% Apply binary search to find the indices.
% If the string is on the list, then find the middle of the indices corresponding to the string.
% If the string is not on the list, then find the gap between two members to insert.

function insertinds = find_insert_pos(list, str)

n=length(list); startind=1; endind=n; middle=ceil((startind+endind)/2); flag=1;

% Apply binary search to find the corresponding index.
while (flag==1)

% list{middle}=str: stop.
if (cstrcmp(list{middle},str)==0)
flag=0;

% list{middle}>str: endind=middle.
elseif (cstrcmp(list{middle},str)>0)
endind=middle; middle=ceil((startind+endind)/2);

% list{middle}<str: startind=middle.
elseif (cstrcmp(list{middle},str)<0)
startind=middle; middle=ceil((startind+endind)/2);

end

% startind=middle or endind=middle: stop.
if ((startind==middle)|(endind==middle))
flag=0;
end

end


% If list{middle}~=str, then return middle-1 and middle.
if (strcmp(list{middle},str)~=1)
if (middle<=2)
a1=cstrcmp(list{1},str); a2=cstrcmp(list{2},str);
if ((a1==1)&(a2==1))
insertinds=[0 1];
elseif ((a1==-1)&(a2==1))
insertinds=[1 2];
else
insertinds=[2 3];
end
elseif (middle>=(n-1))
a1=cstrcmp(list{n-1},str); a2=cstrcmp(list{n},str);
if ((a1==-1)&(a2==-1))
insertinds=[n n+1];
elseif ((a1==-1)&(a2==1))
insertinds=[n-1 n];
else
insertinds=[n-2 n-1];
end
else
insertinds=[middle-1 middle];
end

% Otherwise find the complete list of indices with the same string.
else
i=middle; flag=1; ii=0;
while ((i>=1)&(flag==1))
if (strcmp(list{i},str)~=1)
flag=0; ii=i+1;
end
i=i-1;
end
if (ii==0)
ii=1;
end
j=middle; flag=1; jj=0;
while ((j<=length(list))&(flag==1))
if (strcmp(list{j},str)~=1)
flag=0; jj=j-1;
end
j=j+1;
end
if (jj==0)
jj=length(list);
end
a2=ceil((ii+jj)/2); a1=a2-1;
insertinds=[a1 a2];
end


