% Find the indices of a string in a list of sorted strings.
% Apply binary search to find the indices.
% The members on the list are sorted by alphabets.

function inds = find_str_list(list, str)

n=length(list); startind=1; endind=n; middle=ceil((startind+endind)/2); flag=1;

% Apply binary search to find the corresponding index.
while (flag==1)

% list{middle}=str: stop.
if (cstrcmp(list{middle},str)==0)
flag=0;

% list{middle}>str: endind=middle.
elseif (cstrcmp(list{middle},str)>0)
endind=middle; middle=ceil((startind+endind)/2);

% list{middle}<str: startind=middle.
elseif (cstrcmp(list{middle},str)<0)
startind=middle; middle=ceil((startind+endind)/2);

end

% startind=middle or endind=middle: stop.
if ((startind==middle)|(endind==middle))
flag=0;
end

end

% If list{middle}~=str, then return a null list.
if (strcmp(list{middle},str)~=1)
inds=[];

% Otherwise find the complete list of indices with the same string.
else
i=middle; flag=1; ii=0;
while ((i>=1)&(flag==1))
if (strcmp(list{i},str)~=1)
flag=0; ii=i+1;
end
i=i-1;
end
if (ii==0)
ii=1;
end
j=middle; flag=1; jj=0;
while ((j<=length(list))&(flag==1))
if (strcmp(list{j},str)~=1)
flag=0; jj=j-1;
end
j=j+1;
end
if (jj==0)
jj=length(list);
end
inds=ii:jj;
end


